"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import httpx
import pydantic
from pydantic import model_serializer
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict
from unstructured_client.models.shared import (
    sourceconnectorinformation as shared_sourceconnectorinformation,
    sourceconnectortype as shared_sourceconnectortype,
)
from unstructured_client.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from unstructured_client.utils import FieldMetadata, HeaderMetadata, QueryParamMetadata

LIST_SOURCES_SERVER_PLATFORM_API = "platform-api"
r"""Unstructured Platform API"""

LIST_SOURCES_SERVERS = {
    LIST_SOURCES_SERVER_PLATFORM_API: "https://platform.unstructuredapp.io/",
}


class ListSourcesRequestTypedDict(TypedDict):
    source_type: NotRequired[Nullable[shared_sourceconnectortype.SourceConnectorType]]
    unstructured_api_key: NotRequired[Nullable[str]]


class ListSourcesRequest(BaseModel):
    source_type: Annotated[
        OptionalNullable[shared_sourceconnectortype.SourceConnectorType],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UNSET

    unstructured_api_key: Annotated[
        OptionalNullable[str],
        pydantic.Field(alias="unstructured-api-key"),
        FieldMetadata(header=HeaderMetadata(style="simple", explode=False)),
    ] = UNSET

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["source_type", "unstructured-api-key"]
        nullable_fields = ["source_type", "unstructured-api-key"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class ListSourcesResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    response_list_sources: NotRequired[
        List[shared_sourceconnectorinformation.SourceConnectorInformationTypedDict]
    ]
    r"""Successful Response"""


class ListSourcesResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    response_list_sources: Optional[
        List[shared_sourceconnectorinformation.SourceConnectorInformation]
    ] = None
    r"""Successful Response"""
